//
// Created by Hubert Andrzejewski on 09.06.15.
// Copyright (c) 2015 Hubert Andrzejewski. All rights reserved.
//

#import "MaskLayer.h"


@implementation MaskLayer

//- (void)drawInContext:(CGContextRef)ctx
//{
//    CGContextSetStrokeColorWithColor(ctx, [UIColor whiteColor].CGColor);
//    CGContextSetLineWidth(ctx, 2.0);
//    CGContextStrokeRect(ctx, _maskRect);
//}


- (void)drawInContext:(CGContextRef)ctx
{
    CGRect holeRectIntersection = CGRectIntersection(_maskRect, self.bounds);
    CGPoint orgin = holeRectIntersection.origin;
    CGSize size = holeRectIntersection.size;
    
    CGContextSetAllowsAntialiasing(ctx, YES);
    CGContextSetShouldAntialias(ctx, YES);
    CGContextSetLineJoin(ctx, kCGLineJoinRound);
    CGContextSetLineCap(ctx, kCGLineCapRound);
    
    CGContextSetStrokeColorWithColor(ctx, [UIColor whiteColor].CGColor);
    CGContextSetLineWidth(ctx, 8.0);
    
    CGContextBeginPath(ctx);
    CGContextMoveToPoint(ctx, orgin.x, orgin.y);
    CGContextAddLineToPoint(ctx, orgin.x + 1.0f/4.0f * size.width, orgin.y);
    CGContextMoveToPoint(ctx, orgin.x, orgin.y);
    CGContextAddLineToPoint(ctx, orgin.x , orgin.y + 1.0f/4.0f * size.height);
    CGContextStrokePath(ctx);
    
    CGContextBeginPath(ctx);
    CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y);
    CGContextAddLineToPoint(ctx, orgin.x + 3.0f/4.0f * size.width, orgin.y);
    CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y);
    CGContextAddLineToPoint(ctx, orgin.x + size.width , orgin.y + 1.0f/4.0f * size.height);
    CGContextStrokePath(ctx);
    
    CGContextBeginPath(ctx);
    CGContextMoveToPoint(ctx, orgin.x, orgin.y + size.height);
    CGContextAddLineToPoint(ctx, orgin.x + 1.0f/4.0f * size.width, orgin.y + size.height);
    CGContextMoveToPoint(ctx, orgin.x, orgin.y + size.height);
    CGContextAddLineToPoint(ctx, orgin.x  , orgin.y + 3.0f/4.0f * size.height);
    CGContextStrokePath(ctx);
    
    CGContextBeginPath(ctx);
    CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y + size.height);
    CGContextAddLineToPoint(ctx, orgin.x + 3.0f/4.0f * size.width, orgin.y + size.height);
    CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y + size.height);
    CGContextAddLineToPoint(ctx, orgin.x + size.width , orgin.y + 3.0f/4.0f * size.height);
    CGContextStrokePath(ctx);
    
}
@end