//
//  InfoViewController.swift
//  AztecDemoSwift
//
//  Created by PrimeSoft Polska on 20.04.2016.
//  Copyright © 2016 PrimeSoft Polska. All rights reserved.
//

import UIKit

class InfoViewController: UIViewController {
    
    @IBOutlet weak var textLabel: TTTAttributedLabel!
    
    private let link: NSString = "http://www.aztecreader.com"
    private let content: NSString = "This application presenting possibilities of Aztec Reader SDK which recognizes Aztec codes. If you want to know more then please visit\nhttp://www.aztecreader.com."
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        configureTextView()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func supportedInterfaceOrientations() -> UIInterfaceOrientationMask {
        return .Portrait
    }
    
    func configureTextView() {
        
        let str = NSMutableAttributedString(string: content as String)
        let linkRange = content.rangeOfString(link as String)
        let allRange = content.rangeOfString(content as String)
        
        if #available(iOS 8.2, *) {
            str.addAttribute(NSFontAttributeName, value: UIFont.systemFontOfSize(20.0, weight: UIFontWeightLight), range: allRange)
        } else {
            str.addAttribute(NSFontAttributeName, value: UIFont.systemFontOfSize(20.0), range: allRange)
        }
        
        let paragraph = NSMutableParagraphStyle()
        paragraph.alignment = .Center
        paragraph.lineSpacing = 7.0
        str.addAttribute(NSParagraphStyleAttributeName, value: paragraph, range: allRange)
        
        let color = UIColor(red: 230.0/255.0, green: 52.0/255.0, blue: 29.0/255.0, alpha: 1.0)
        str.addAttribute(NSForegroundColorAttributeName, value: color, range: linkRange)
        
        textLabel.attributedText = NSAttributedString(attributedString: str)
        textLabel.addLinkToURL(NSURL(string: link as String), withRange: linkRange)
        textLabel.attributedText = NSAttributedString(attributedString: str)
    }
}

extension InfoViewController: TTTAttributedLabelDelegate {
    func attributedLabel(label: TTTAttributedLabel!, didSelectLinkWithURL url: NSURL!) {
        UIApplication.sharedApplication().openURL(url)
    }
}
