//
//  MaskLayer.swift
//  Scan and Paste
//
//  Created by PrimeSoft Polska on 30.11.2015.
//  Copyright © 2015 PrimeSoft Polska. All rights reserved.
//

import UIKit

public class MaskLayer: CALayer {
    public var maskRect: CGRect!

//    public override func drawInContext(ctx: CGContext) {
//        CGContextSetStrokeColorWithColor(ctx, UIColor.whiteColor().CGColor)
//        CGContextSetLineWidth(ctx, 2.0)
//        CGContextStrokeRect(ctx, self.maskRect)
//    }
    
    public override func drawInContext(ctx: CGContext) {
        let holeRectIntersection:CGRect = CGRectIntersection(self.maskRect, self.bounds);
        let orgin:CGPoint = holeRectIntersection.origin;
        let size:CGSize = holeRectIntersection.size;
        
        CGContextSetAllowsAntialiasing(ctx, true);
        CGContextSetShouldAntialias(ctx, true);
        CGContextSetLineJoin(ctx,  .Round);
        CGContextSetLineCap(ctx, .Round);
        
        CGContextSetStrokeColorWithColor(ctx, UIColor.whiteColor().CGColor);
        CGContextSetLineWidth(ctx, 8.0);
        
        CGContextBeginPath(ctx);
        CGContextMoveToPoint(ctx, orgin.x, orgin.y);
        CGContextAddLineToPoint(ctx, orgin.x + 1.0/4.0 * size.width, orgin.y);
        CGContextMoveToPoint(ctx, orgin.x, orgin.y);
        CGContextAddLineToPoint(ctx, orgin.x , orgin.y + 1.0/4.0 * size.height);
        CGContextStrokePath(ctx);
        
        CGContextBeginPath(ctx);
        CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y);
        CGContextAddLineToPoint(ctx, orgin.x + 3.0/4.0 * size.width, orgin.y);
        CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y);
        CGContextAddLineToPoint(ctx, orgin.x + size.width , orgin.y + 1.0/4.0 * size.height);
        CGContextStrokePath(ctx);
        
        CGContextBeginPath(ctx);
        CGContextMoveToPoint(ctx, orgin.x, orgin.y + size.height);
        CGContextAddLineToPoint(ctx, orgin.x + 1.0/4.0 * size.width, orgin.y + size.height);
        CGContextMoveToPoint(ctx, orgin.x, orgin.y + size.height);
        CGContextAddLineToPoint(ctx, orgin.x  , orgin.y + 3.0/4.0 * size.height);
        CGContextStrokePath(ctx);
        
        CGContextBeginPath(ctx);
        CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y + size.height);
        CGContextAddLineToPoint(ctx, orgin.x + 3.0/4.0 * size.width, orgin.y + size.height);
        CGContextMoveToPoint(ctx, orgin.x + size.width, orgin.y + size.height);
        CGContextAddLineToPoint(ctx, orgin.x + size.width , orgin.y + 3.0/4.0 * size.height);
        CGContextStrokePath(ctx);

    }
}
